------------------------------------------------------------------------------
--                                                                          --
--                         BlackShield COMPONENTS                           --
--                                                                          --
--                             E B N F 2 I D L                              --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                     Copyright (C) 2010, J. Hugues.                       --
--                                                                          --
-- BlackShield is free software;  you  can  redistribute  it and/or  modify --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. BlackShield is distributed  in  the  hope  that it will be--
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with BlackShield; see file COPYING--
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--   BlackShield is maintained by Jerome Hugues <hugues.jerome@gmail.com>   --
--                                                                          --
------------------------------------------------------------------------------

with Types;
--# inherit EBNF.Nodes,
--#         EBNF.Printer,
--#         Errors,
--#         Namet,
--#         Output,
--#         Spark.Command_Line,
--#         Types;

package EBNF2IDL is

   procedure Generate (N : Types.Node_Id);

private

   procedure Generate_Prologue;
   procedure Decorate_Tree (N : Types.Node_Id);

   function Normalize_Meta_Identifier (N : Types.Node_Id) return Types.Name_Id;

   function Is_Terminal (N : Types.Node_Id) return Boolean;
   --  Return true iff the corresponding syntax rule denotes a
   --  terminal.

   function Is_Lexer_Terminal (N : Types.Node_Id) return Boolean;
   --  Return true ifff the corresponding syntax rule denotes a
   --  terminal or a lexer.

end EBNF2IDL;
