------------------------------------------------------------------------------
--                                                                          --
--                         BlackShield COMPONENTS                           --
--                                                                          --
--                                 H E L P                                  --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                     Copyright (C) 2010, J. Hugues.                       --
--                                                                          --
-- BlackShield is free software;  you  can  redistribute  it and/or  modify --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. BlackShield is distributed  in  the  hope  that it will be--
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with BlackShield; see file COPYING--
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--   BlackShield is maintained by Jerome Hugues <hugues.jerome@gmail.com>   --
--                                                                          --
------------------------------------------------------------------------------

with Output;
with Version;

package body Help is

   -----------
   -- Usage --
   -----------

   procedure Usage is
   begin
      Output.Set_Standard_Output;
      Output.Write_Line ("Usage: bs [options] filename");
      Output.Write_Line ("Options:");
      Output.Write_Line ("  --help       Display this help and exit");
      Output.Write_Line ("  --version    Display version and exit");
      Output.Write_Line ("  --idl        Generate IDL spec for AST");
      Output.Write_Eol;
      Output.Write_Line ("Report bugs to <hugues.jerome@gmail.com>");
   end Usage;

   ------------------
   -- Show_Version --
   ------------------

   procedure Show_Version is
   begin
      Output.Set_Standard_Output;
      Output.Write_Line
        ("blackshield " &
         Version.Tool_Version &
         " (" &
         Version.SVN_Revision &
         ")");
      Output.Write_Line ("Copyright (c) 2010 J. Hugues");
      Output.Write_Eol;
      Output.Write_Line ("LICENSE: BlackShield is released under the "
                           & "GMGPL.");
      Output.Write_Eol;
      Output.Write_Line
        ("Written by Jerome Hugues <hugues.jerome@gmail.com>");
   end Show_Version;

end Help;
