------------------------------------------------------------------------------
--                                                                          --
--                         BlackShield COMPONENTS                           --
--                                                                          --
--                            L O C A T I O N S                             --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                     Copyright (C) 2010, J. Hugues.                       --
--                                                                          --
-- BlackShield is free software;  you  can  redistribute  it and/or  modify --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. BlackShield is distributed  in  the  hope  that it will be--
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with BlackShield; see file COPYING--
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--   BlackShield is maintained by Jerome Hugues <hugues.jerome@gmail.com>   --
--                                                                          --
------------------------------------------------------------------------------

with Types;
with Spark.Strings;
--# inherit Namet,
--#         Spark.Strings,
--#         Types;

package Locations is

   type Location is record
      Base_Name : Types.Name_Id;  --  Base name of file
      Dir_Name  : Types.Name_Id;  --  Directory name of file
      Line      : Types.Nat;      --  Index of current line in buffer
      First_Pos : Types.Text_Ptr; --  Index of first character in the line
      Last_Pos  : Types.Text_Ptr; --  Index of last character read on the line
      Scan      : Types.Text_Ptr; --  Index of current character in the line
      EOF       : Types.Text_Ptr; --  Index of very last character in buffer
   end record;

   No_Location : constant Location :=
      Location'(Types.No_Name, Types.No_Name, 1, 1, 1, 1, 1);

   procedure Location_Image
     (Loc : Location;
      Img : out Spark.Strings.SparkString);
   --# global in out Namet.Name_Buffer;
   --#        in out Namet.Name_Len;
   --#        in out Namet.State;
   --  Return <base_name>:<line>:<column>. If Base_Name is null, then
   --  return null string.

end Locations;
