------------------------------------------------------------------------------
--                                                                          --
--                         BlackShield COMPONENTS                           --
--                                                                          --
--                   S P A R K . C O M M A N D _ L I N E                    --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                     Copyright (C) 2010, J. Hugues.                       --
--                                                                          --
-- BlackShield is free software;  you  can  redistribute  it and/or  modify --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. BlackShield is distributed  in  the  hope  that it will be--
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with BlackShield; see file COPYING--
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--   BlackShield is maintained by Jerome Hugues <hugues.jerome@gmail.com>   --
--                                                                          --
------------------------------------------------------------------------------

with Ada.Command_Line;

package body Spark.Command_Line is
   --  This package relies directly on the functions defined in
   --  Ada.Command_Line, thus they are hidden.

   --# hide Spark.Command_Line;

   --------------------
   -- Argument_Count --
   --------------------

   function Argument_Count return Natural is
   begin
      return Ada.Command_Line.Argument_Count;
   end Argument_Count;

   --------------
   -- Argument --
   --------------

   function Argument (Number : Positive) return Spark.Strings.SparkString is
      Result : Spark.Strings.SparkString;
   begin
      Spark.Strings.CopyString (Result, Ada.Command_Line.Argument (Number));

      return Result;
   end Argument;

   ------------------
   -- Command_Name --
   ------------------

   function Command_Name return  Spark.Strings.SparkString is
      Result : Spark.Strings.SparkString;
   begin
      Spark.Strings.CopyString (Result, Ada.Command_Line.Command_Name);

      return Result;
   end Command_Name;

   ---------------------
   -- Set_Exit_Status --
   ---------------------

   procedure Set_Exit_Status (Code : Exit_Status) is
   begin
      Ada.Command_Line.Set_Exit_Status (Ada.Command_Line.Exit_Status (Code));
   end Set_Exit_Status;

end Spark.Command_Line;
