------------------------------------------------------------------------------
--                                                                          --
--                         BlackShield COMPONENTS                           --
--                                                                          --
--                     S P A R K . T Y P E _ I M A G E                      --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                     Copyright (C) 2010, J. Hugues.                       --
--                                                                          --
-- BlackShield is free software;  you  can  redistribute  it and/or  modify --
-- it under terms of the GNU General Public License as published by the     --
-- Free Software Foundation; either version 2, or (at your option) any      --
-- later version. BlackShield is distributed  in  the  hope  that it will be--
-- useful, but WITHOUT ANY WARRANTY;  without even the implied warranty of  --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details. You should have received  a copy of the --
-- GNU General Public License distributed with BlackShield; see file COPYING--
-- If not, write to the Free Software Foundation, 51 Franklin Street, Fifth --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable to be   --
-- covered  by the  GNU  General  Public  License. This exception does not  --
-- however invalidate  any other reasons why the executable file might be   --
-- covered by the GNU Public License.                                       --
--                                                                          --
--   BlackShield is maintained by Jerome Hugues <hugues.jerome@gmail.com>   --
--                                                                          --
------------------------------------------------------------------------------

package body Spark.Type_Image is

   -------------------
   -- Boolean_Image --
   -------------------

   function Boolean_Image (N : Boolean) return Strings.SparkString is
      Result : Strings.SparkString;
   begin
      if N then
         Strings.CopyString (Result, "TRUE");
      else
         Strings.CopyString (Result, "FALSE");
      end if;

      return Result;
   end Boolean_Image;

   -------------------
   -- Integer_Image --
   -------------------

   function Integer_Image (N : Integer) return Strings.SparkString is
      Result : Strings.SparkString := Strings.EmptyString;
      V      : Integer;
      Index  : Strings.Positions;
   begin
      if N >= 0 then
         V := -N;
      else
         V := N;
      end if;

      Result.Length := Strings.MaxStringLength;

      for J in reverse Natural range
            Strings.MaxStringLength - 20 .. Strings.MaxStringLength
      loop
         Index := J;
         --# assert (J in (Strings.MaxStringLength - 20) ..
         --#               (Strings.MaxStringLength)) and Index = J and V <= 0;

         exit when V > -10;
         Result.Text (J) :=
            Character'Val (Character'Pos ('0') - (V rem 10));
         V               := V / 10;
      end loop;

      Result.Text (Index) :=
         Character'Val (Character'Pos ('0') - (V rem 10));

      if N < 0 then
         Index               := Index - 1;
         Result.Text (Index) := '-';
      end if;

      Result := Strings.Substring (Result, Index, Strings.MaxStringLength);
      return Result;
   end Integer_Image;

end Spark.Type_Image;
